<?
Class network
{
	var $cookie_file;
	var $debug;
	
	var $last_location_url;
	
	var $sessions=array();
	
	function network($debug=false)
	{
		$this->debug=$debug;
	}
	
	function new_session($name, $cookies=false)
	{
		if(isset($this->sessions[$name]))
		{
			$this->close_session($name);
		}
		
		clearstatcache();
		
		$cookie_file=tempnam("/tmp", "cookie");
		fclose(fopen($cookie_file, 'w'));
		
		$this->sessions[$name]=array(
			'ch'=>curl_init(),
			'cookies'=>$cookie_file,
		);
	}
	
	function request($session, $url, $post_data=false)
	{
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_URL, $url);
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.19) Gecko/2010031422 Firefox/3.0.19');
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_COOKIEJAR, $this->sessions[$session]['cookies']);
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_COOKIEFILE, $this->sessions[$session]['cookies']);
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_REFERER, $url);
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_HEADER, 0);
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_RETURNTRANSFER, 1);
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt ($this->sessions[$session]['ch'], CURLOPT_TIMEOUT, 120);
		
		if(preg_match('!https://!', $url))
		{
			curl_setopt($this->sessions[$session]['ch'], CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($this->sessions[$session]['ch'], CURLOPT_SSL_VERIFYHOST, FALSE);
		}
		
		if($post_data)
		{
			curl_setopt ($this->sessions[$session]['ch'], CURLOPT_POST, 1);
			curl_setopt ($this->sessions[$session]['ch'], CURLOPT_POSTFIELDS, $post_data);
		}
		
		$data=curl_exec($this->sessions[$session]['ch']);
		
		$this->last_location_url=curl_getinfo($this->sessions[$session]['ch'], CURLINFO_EFFECTIVE_URL);
		
		$curl_error=curl_error($this->sessions[$session]['ch']);
		
		if($curl_error && $this->debug)
		{
			print '<div><font color="red">network.class.php: '.$curl_error.'</font></div>';
		}
		
		return $data;
	}
	
	function close_session($name)
	{
		@curl_close($this->sessions[$name]['ch']);
		@unlink($this->sessions[$name]['cookies']);
	}
	
	//Other Functions
	function array_urlencode($array)
	{
		foreach($array as $p=>$v)
		{
			$array[]=urlencode($p).'='.urlencode($v);
			unset($array[$p]);
		}
		
		return implode('&', $array);
	}
	
	function array_urldecode($str)
	{
		$str=explode('&', $str);
		
		foreach($str as $id=>$value)
		{
			unset($str[$id]);
			
			$value=explode('=', $value);
			
			$str[urldecode($value[0])]=urldecode($value[1]);
		}
		
		return $str;
	}
	
	//HTML Form Functions
	function htmlform_get_all_hidden_inputs($data)
	{
		preg_match_all('!<input[^>]*type=["\']*hidden["\']*[^>]*>!iUs', $data, $maches, PREG_SET_ORDER);
		
		$result=array();
		
		foreach($maches as $mach)
		{
			preg_match('!name=[\'"]([^\'"]*)[\'"]!iUs', $mach[0], $m);
			$key=$m[1];
			
			preg_match('!value=[\'"]([^\'"]*)[\'"]!iUs', $mach[0], $m);
			$value=$m[1];
			
			$result[$key]=$value;
		}
		
		return $result;
	}
	
	function clear()
	{
		foreach($this->sessions as $session=>$data)
		{
			$this->close_session($session);
		}
	}
}
?>